Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 4647)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 4648)
@@ -1,73 +1,72 @@
 !> @file init_pegrid.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4564 2020-06-12 14:03:36Z raasch
 ! Vertical nesting method of Huq et al. (2019) removed
-! 
+!
 ! 4461 2020-03-12 16:51:59Z raasch
 ! communicator configurations for four virtual pe grids defined
-! 
+!
 ! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! changed message PA0467
-! 
+!
 ! 4264 2019-10-15 16:00:23Z scharf
 ! corrected error message string
-! 
+!
 ! 4241 2019-09-27 06:32:47Z raasch
-! Check added to ensure that subdomain grid has at least the size as given by the number
-! of ghost points
-! 
+! Check added to ensure that subdomain grid has at least the size as given by the number of ghost
+! points
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4045 2019-06-21 10:58:47Z raasch
-! bugfix: kind attribute added to nint function to allow for large integers which may appear in
-! case of default recycling width and small grid spacings
-! 
+! bugfix: kind attribute added to nint function to allow for large integers which may appear in case
+!         of default recycling width and small grid spacings
+!
 ! 3999 2019-05-23 16:09:37Z suehring
 ! Spend 3 ghost points also in case of pw-scheme when nesting is applied
-! 
+!
 ! 3897 2019-04-15 11:51:14Z suehring
 ! Minor revision of multigrid check; give warning instead of an abort.
-! 
+!
 ! 3890 2019-04-12 15:59:20Z suehring
-! Check if grid coarsening is possible on subdomain, in order to avoid that 
-! multigrid approach effectively reduces to a Gauss-Seidel scheme.
-! 
+! Check if grid coarsening is possible on subdomain, in order to avoid that multigrid approach
+! effectively reduces to a Gauss-Seidel scheme.
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
-! of additional debug messages
-! 
+! Changes related to global restructuring of location messages and introduction of additional debug
+! messages
+!
 ! 3884 2019-04-10 13:31:55Z Giersch
 ! id_recycling is only calculated in case of tubulent inflow
-! 
+!
 ! 3761 2019-02-25 15:31:42Z raasch
 ! unused variable removed
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! variables documented
@@ -79,66 +78,57 @@
 ! Description:
 ! ------------
-!> Determination of the virtual processor topology (if not prescribed by the
-!> user)and computation of the grid point number and array bounds of the local
-!> domains.
-!> @todo: remove MPI-data types for 2D exchange on coarse multigrid level (not
-!>        used any more) 
-!------------------------------------------------------------------------------!
+!> Determination of the virtual processor topology (if not prescribed by the user) and computation
+!> of the grid point number and array bounds of the local domains.
+!> @todo: remove MPI-data types for 2D exchange on coarse multigrid level (not used any more)
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE init_pegrid
- 
-
-    USE control_parameters,                                                    &
-        ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r, bc_dirichlet_s, &
-               bc_lr, bc_ns, bc_radiation_l, bc_radiation_n, bc_radiation_r,   &
-               bc_radiation_s, &
-               grid_level, grid_level_count, maximum_grid_level,               &
-               message_string, mg_switch_to_pe0_level,         &
-               psolver
+
+
+    USE control_parameters,                                                                        &
+        ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r, bc_dirichlet_s, bc_lr, bc_ns,       &
+               bc_radiation_l, bc_radiation_n, bc_radiation_r, bc_radiation_s, grid_level,         &
+               grid_level_count, maximum_grid_level, message_string, mg_switch_to_pe0_level, psolver
 
 
 #if defined( __parallel )
-    USE control_parameters,                                                    &
-        ONLY:  coupling_mode, coupling_topology, gathered_size, momentum_advec, &
-               outflow_source_plane, recycling_width, scalar_advec, subdomain_size, &
+    USE control_parameters,                                                                        &
+        ONLY:  coupling_mode, coupling_topology, gathered_size, momentum_advec,                    &
+               outflow_source_plane, recycling_width, scalar_advec, subdomain_size,                &
                turbulent_inflow, turbulent_outflow, y_shift
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  dx
 #endif
-        
-    USE indices,                                                               &
-        ONLY:  nnx, nny, nnz, nx, nxl, nxl_mg,   &
-               nxlu, nxr, nxr_mg, ny, nyn, nyn_mg, nys, nys_mg,    &
-               nysv, nz, nzb, nzt, nzt_mg, wall_flags_1, wall_flags_2,         &
-               wall_flags_3, wall_flags_4, wall_flags_5, wall_flags_6,         &
-               wall_flags_7, wall_flags_8, wall_flags_9, wall_flags_10
+
+    USE indices,                                                                                   &
+        ONLY:  nnx, nny, nnz, nx, nxl, nxl_mg, nxlu, nxr, nxr_mg, ny, nyn, nyn_mg, nys, nys_mg,    &
+               nysv, nz, nzb, nzt, nzt_mg, wall_flags_1, wall_flags_2, wall_flags_3, wall_flags_4, &
+               wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8, wall_flags_9, wall_flags_10
 
 #if defined( __parallel )
-    USE indices,                                                               &
+    USE indices,                                                                                   &
         ONLY:  mg_loc_ind, nbgp, nx_a, nx_o, ny_a, ny_o
 #endif
 
     USE kinds
-      
+
     USE pegrid
-    
+
 #if defined( __parallel )
-    USE pmc_interface,                                                         &
+    USE pmc_interface,                                                                             &
         ONLY:  nested_run
 
-    USE spectra_mod,                                                           &
+    USE spectra_mod,                                                                               &
         ONLY:  calculate_spectra
 
-    USE synthetic_turbulence_generator_mod,                                    &
-        ONLY:  id_stg_left, id_stg_north, id_stg_right, id_stg_south,          &
-               use_syn_turb_gen
+    USE synthetic_turbulence_generator_mod,                                                        &
+        ONLY:  id_stg_left, id_stg_north, id_stg_right, id_stg_south, use_syn_turb_gen
 #endif
 
-    USE transpose_indices,                                                     &
-        ONLY:  nxl_y, nxl_z, nxr_y, nxr_z, nyn_x, nyn_z, nys_x,&
-               nys_z, nzb_x, nzb_y, nzt_x, nzt_y
+    USE transpose_indices,                                                                         &
+        ONLY:  nxl_y, nxl_z, nxr_y, nxr_z, nyn_x, nyn_z, nys_x, nys_z, nzb_x, nzb_y, nzt_x, nzt_y
 
 #if defined( __parallel )
-    USE transpose_indices,                                                     &
+    USE transpose_indices,                                                                         &
         ONLY:  nxl_yd, nxr_yd, nzb_yd, nzt_yd
 #endif
@@ -152,8 +142,8 @@
     INTEGER(iwp) ::  id_outflow_source_l      !< local value of id_outflow_source
     INTEGER(iwp) ::  id_recycling_l           !< ID indicating processors located at the recycling plane
-    INTEGER(iwp) ::  id_stg_left_l            !< left lateral boundary local core id in case of turbulence generator  
-    INTEGER(iwp) ::  id_stg_north_l           !< north lateral boundary local core id in case of turbulence generator  
-    INTEGER(iwp) ::  id_stg_right_l           !< right lateral boundary local core id in case of turbulence generator  
-    INTEGER(iwp) ::  id_stg_south_l           !< south lateral boundary local core id in case of turbulence generator  
+    INTEGER(iwp) ::  id_stg_left_l            !< left lateral boundary local core id in case of turbulence generator
+    INTEGER(iwp) ::  id_stg_north_l           !< north lateral boundary local core id in case of turbulence generator
+    INTEGER(iwp) ::  id_stg_right_l           !< right lateral boundary local core id in case of turbulence generator
+    INTEGER(iwp) ::  id_stg_south_l           !< south lateral boundary local core id in case of turbulence generator
     INTEGER(iwp) ::  ind(5)                   !< array containing the subdomain bounds
 #endif
@@ -222,10 +212,10 @@
 
 !
-!--    Prescribed by user. Number of processors on the prescribed topology
-!--    must be equal to the number of PEs available to the job
+!--    Prescribed by user. Number of processors on the prescribed topology must be equal to the
+!--    number of PEs available to the job
        IF ( ( npex * npey ) /= numprocs )  THEN
-          WRITE( message_string, * ) 'number of PEs of the prescribed ',       &
-              'topology (', npex*npey,') does not match & the number of ',     &
-              'PEs available to the job (', numprocs, ')'
+          WRITE( message_string, * ) 'number of PEs of the prescribed ', 'topology (', npex*npey,  &
+                                     ') does not match & the number of ',                          &
+                                     'PEs available to the job (', numprocs, ')'
           CALL message( 'init_pegrid', 'PA0221', 1, 2, 0, 6, 0 )
        ENDIF
@@ -237,7 +227,7 @@
 !--    If the processor topology is prescribed by the user, the number of
 !--    PEs must be given in both directions
-       message_string = 'if the processor topology is prescribed by th' //     &
-                'e user & both values of "npex" and "npey" must be given' //   &
-                ' in the &NAMELIST-parameter file'
+       message_string = 'if the processor topology is prescribed by th' //                         &
+                        'e user & both values of "npex" and "npey" must be given' //               &
+                        ' in the &NAMELIST-parameter file'
        CALL message( 'init_pegrid', 'PA0222', 1, 2, 0, 6, 0 )
 
@@ -245,6 +235,6 @@
 
 !
-!-- Create four default MPI communicators for the 2d virtual PE grid. One of them will be used
-!-- as the main communicator for this run, while others might be used for specific quantities like
+!-- Create four default MPI communicators for the 2d virtual PE grid. One of them will be used as
+!-- the main communicator for this run, while others might be used for specific quantities like
 !-- aerosol, chemical species, or passive scalars), if their horizontal boundary conditions shall
 !-- be different from those of the other quantities (e.g. non-cyclic conditions for aerosols, and
@@ -297,12 +287,10 @@
 
 !
-!-- In case of cyclic boundary conditions, a y-shift at the boundaries in
-!-- x-direction can be introduced via parameter y_shift. The shift is done
-!-- by modifying the processor grid in such a way that processors located
-!-- at the x-boundary communicate across it to processors with y-coordinate
-!-- shifted by y_shift relative to their own. This feature can not be used
-!-- in combination with an fft pressure solver. It has been implemented to
-!-- counter the effect of streak structures in case of cyclic boundary
-!-- conditions. For a description of these see Munters
+!-- In case of cyclic boundary conditions, a y-shift at the boundaries in x-direction can be
+!-- introduced via parameter y_shift. The shift is done by modifying the processor grid in such a
+!-- way that processors located at the x-boundary communicate across it to processors with
+!-- y-coordinate shifted by y_shift relative to their own. This feature can not be used in
+!-- combination with an fft pressure solver. It has been implemented to counter the effect of streak
+!-- structures in case of cyclic boundary conditions. For a description of these see Munters
 !-- (2016; dx.doi.org/10.1063/1.4941912)
 !--
@@ -310,7 +298,5 @@
     IF ( y_shift /= 0 ) THEN
        IF ( bc_lr == 'cyclic' ) THEN
-          IF ( TRIM( psolver ) /= 'multigrid' .AND.                            &
-                TRIM( psolver ) /= 'multigrid_noopt')                          &
-          THEN
+          IF ( TRIM( psolver ) /= 'multigrid' .AND.  TRIM( psolver ) /= 'multigrid_noopt')  THEN
              message_string = 'y_shift /= 0 requires a multigrid pressure solver '
              CALL message( 'check_parameters', 'PA0468', 1, 2, 0, 6, 0 )
@@ -320,34 +306,33 @@
           CALL MPI_CART_COORDS( comm2d, pleft, ndim, lcoord, ierr )
 
-!   
-!--       If the x(y)-coordinate of the right (left) neighbor is smaller (greater)
-!--       than that of the calling process, then the calling process is located on
-!--       the right (left) boundary of the processor grid. In that case,
-!--       the y-coordinate of that neighbor is increased (decreased) by y_shift.
-!--       The rank of the process with that coordinate is then inquired and the
-!--       neighbor rank for MPI_SENDRECV, pright (pleft) is set to it.
-!--       In this way, the calling process receives a new right (left) neighbor
-!--       for all future MPI_SENDRECV calls. That neighbor has a y-coordinate
-!--       of y+(-)y_shift, where y is the original right (left) neighbor's
-!--       y-coordinate. The modulo-operation ensures that if the neighbor's
-!--       y-coordinate exceeds the grid-boundary, it will be relocated to
-!--       the opposite part of the grid cyclicly.
-          IF ( rcoord(1) < pcoord(1) ) THEN
+!
+!--       If the x(y)-coordinate of the right (left) neighbor is smaller (greater) than that of the
+!--       calling process, then the calling process is located on the right (left) boundary of the
+!--       processor grid. In that case, the y-coordinate of that neighbor is increased (decreased)
+!--       by y_shift.
+!--       The rank of the process with that coordinate is then inquired and the neighbor rank for
+!--       MPI_SENDRECV, pright (pleft) is set to it.
+!--       In this way, the calling process receives a new right (left) neighbor for all future
+!--       MPI_SENDRECV calls. That neighbor has a y-coordinate of y+(-)y_shift, where y is the
+!--       original right (left) neighbor's y-coordinate. The modulo-operation ensures that if the
+!--       neighbor's y-coordinate exceeds the grid-boundary, it will be relocated to the opposite
+!--       part of the grid cyclicly.
+          IF ( rcoord(1) < pcoord(1) )  THEN
              rcoord(2) = MODULO( rcoord(2) + y_shift, pdims(2) )
              CALL MPI_CART_RANK( comm2d, rcoord, pright, ierr )
           ENDIF
 
-          IF ( lcoord(1) > pcoord(1) ) THEN
+          IF ( lcoord(1) > pcoord(1) )  THEN
              lcoord(2) = MODULO( lcoord(2) - y_shift, pdims(2) )
              CALL MPI_CART_RANK( comm2d, lcoord, pleft, ierr )
           ENDIF
-         
+
        ELSE
 !
-!--       y-shift for non-cyclic boundary conditions is only implemented 
+!--       y-shift for non-cyclic boundary conditions is only implemented
 !--       for the turbulence recycling method in inflow_turbulence.f90
           IF ( .NOT. turbulent_inflow )  THEN
-             message_string = 'y_shift /= 0 is only allowed for cyclic ' //    &
-                              'boundary conditions in both directions '  //    &
+             message_string = 'y_shift /= 0 is only allowed for cyclic ' //                        &
+                              'boundary conditions in both directions '  //                        &
                               'or with turbulent_inflow == .TRUE.'
              CALL message( 'check_parameters', 'PA0467', 1, 2, 0, 6, 0 )
@@ -373,11 +358,10 @@
 !
 !-- Calculate array bounds along x-direction for every PE.
-    ALLOCATE( nxlf(0:pdims(1)-1), nxrf(0:pdims(1)-1), nynf(0:pdims(2)-1),      &
-              nysf(0:pdims(2)-1) )
+    ALLOCATE( nxlf(0:pdims(1)-1), nxrf(0:pdims(1)-1), nynf(0:pdims(2)-1), nysf(0:pdims(2)-1) )
 
     IF ( MOD( nx+1 , pdims(1) ) /= 0 )  THEN
-       WRITE( message_string, * ) 'x-direction: gridpoint number (',nx+1,') ', &
-                                  'is not an& integral multiple of the number',&
-                                  ' of processors (',pdims(1),')'
+       WRITE( message_string, * ) 'x-direction: gridpoint number (' ,nx+1, ') ',                   &
+                                  'is not an& integral multiple of the number',                    &
+                                  ' of processors (', pdims(1), ')'
        CALL message( 'init_pegrid', 'PA0225', 1, 2, 0, 6, 0 )
     ELSE
@@ -395,7 +379,7 @@
 !-- Calculate array bounds in y-direction for every PE.
     IF ( MOD( ny+1 , pdims(2) ) /= 0 )  THEN
-       WRITE( message_string, * ) 'y-direction: gridpoint number (',ny+1,') ', &
-                                  'is not an& integral multiple of the number',&
-                                  ' of processors (',pdims(2),')'
+       WRITE( message_string, * ) 'y-direction: gridpoint number (', ny+1, ') ',                   &
+                                  'is not an& integral multiple of the number',                    &
+                                  ' of processors (', pdims(2), ')'
        CALL message( 'init_pegrid', 'PA0227', 1, 2, 0, 6, 0 )
     ELSE
@@ -421,6 +405,5 @@
 
 !
-!-- Set switches to define if the PE is situated at the border of the virtual
-!-- processor grid
+!-- Set switches to define if the PE is situated at the border of the virtual processor grid
     IF ( nxl == 0 )   left_border_pe  = .TRUE.
     IF ( nxr == nx )  right_border_pe = .TRUE.
@@ -429,8 +412,8 @@
 
 !
-!-- Calculate array bounds and gridpoint numbers for the transposed arrays
-!-- (needed in the pressure solver)
-!-- For the transposed arrays, cyclic boundaries as well as top and bottom
-!-- boundaries are omitted, because they are obstructive to the transposition
+!-- Calculate array bounds and gridpoint numbers for the transposed arrays (needed in the pressure
+!-- solver)
+!-- For the transposed arrays, cyclic boundaries as well as top and bottom boundaries are omitted,
+!-- because they are obstructive to the transposition
 
 !
@@ -441,7 +424,7 @@
        IF ( pdims(2) /= 1 )  THEN
           IF ( MOD( nz , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition z --> x:& ',              &
-                                        'nz=',nz,' is not an integral multiple ',&
-                                        'of pdims(1)=',pdims(1)
+             WRITE( message_string, * ) 'transposition z --> x:& ',                                &
+                                        'nz=', nz, ' is not an integral multiple ',                &
+                                        'of pdims(1)=', pdims(1)
              CALL message( 'init_pegrid', 'PA0230', 1, 2, 0, 6, 0 )
           ENDIF
@@ -463,7 +446,7 @@
 !--    2. transposition  x --> y
        IF ( MOD( nx+1 , pdims(2) ) /= 0 )  THEN
-          WRITE( message_string, * ) 'transposition x --> y:& ',              &
-                                     'nx+1=',nx+1,' is not an integral ',     &
-                                     'multiple of pdims(2)=',pdims(2)
+          WRITE( message_string, * ) 'transposition x --> y:& ',                                   &
+                                     'nx+1=', nx+1, ' is not an integral ',                        &
+                                     'multiple of pdims(2)=', pdims(2)
           CALL message( 'init_pegrid', 'PA0231', 1, 2, 0, 6, 0 )
        ENDIF
@@ -492,7 +475,7 @@
 !--       along x, except that the uptream-spline method is switched on
           IF ( MOD( ny+1 , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition y --> z:& ',            &
-                                        'ny+1=',ny+1,' is not an integral ',   &
-                                        'multiple of pdims(1)=',pdims(1)
+             WRITE( message_string, * ) 'transposition y --> z:& ',                                &
+                                        'ny+1=', ny+1, ' is not an integral ',                     &
+                                        'multiple of pdims(1)=', pdims(1)
              CALL message( 'init_pegrid', 'PA0232', 1, 2, 0, 6, 0 )
           ENDIF
@@ -503,7 +486,7 @@
 !--       This condition must be fulfilled for a 1D-decomposition along x
           IF ( MOD( ny+1 , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition x --> y:& ',            &
-                                        'ny+1=',ny+1,' is not an integral ',   &
-                                        'multiple of pdims(1)=',pdims(1)
+             WRITE( message_string, * ) 'transposition x --> y:& ',                                &
+                                        'ny+1=', ny+1, ' is not an integral ',                     &
+                                        'multiple of pdims(1)=', pdims(1)
              CALL message( 'init_pegrid', 'PA0233', 1, 2, 0, 6, 0 )
           ENDIF
@@ -517,7 +500,7 @@
     IF ( calculate_spectra )  THEN
        IF ( MOD( nz, pdims(2) ) /= 0 )  THEN
-          WRITE( message_string, * ) 'direct transposition z --> y (needed ',  &
-                                     'for spectra):& nz=',nz,' is not an ',    &
-                                     'integral multiple of pdims(2)=',pdims(2)
+          WRITE( message_string, * ) 'direct transposition z --> y (needed ',                      &
+                                     'for spectra):& nz=', nz, ' is not an ',                      &
+                                     'integral multiple of pdims(2)=', pdims(2)
           CALL message( 'init_pegrid', 'PA0234', 1, 2, 0, 6, 0 )
        ELSE
@@ -532,5 +515,5 @@
     IF ( psolver == 'poisfft'  .OR.  calculate_spectra )  THEN
 !
-!--    Indices for direct transpositions y --> x 
+!--    Indices for direct transpositions y --> x
 !--    (they are only possible in case of a 1d-decomposition along x)
        IF ( pdims(2) == 1 )  THEN
@@ -547,5 +530,5 @@
     IF ( psolver == 'poisfft' )  THEN
 !
-!--    Indices for direct transpositions x --> y 
+!--    Indices for direct transpositions x --> y
 !--    (they are only possible in case of a 1d-decomposition along y)
        IF ( pdims(1) == 1 )  THEN
@@ -579,6 +562,5 @@
 !--    Receive data from all other PEs
        DO  i = 1, numprocs-1
-          CALL MPI_RECV( ibuf, 4, MPI_INTEGER, i, MPI_ANY_TAG, comm2d, status, &
-                         ierr )
+          CALL MPI_RECV( ibuf, 4, MPI_INTEGER, i, MPI_ANY_TAG, comm2d, status, ierr )
           hor_index_bounds(:,i) = ibuf(1:4)
        ENDDO
@@ -602,18 +584,14 @@
        PRINT*, '*** processor topology ***'
        PRINT*, ' '
-       PRINT*, 'myid   pcoord    left right  south north  idx idy   nxl: nxr',&
-               &'   nys: nyn'
-       PRINT*, '------------------------------------------------------------',&
-               &'-----------'
-       WRITE (*,1000)  0, pcoord(1), pcoord(2), pleft, pright, psouth, pnorth, &
-                       myidx, myidy, nxl, nxr, nys, nyn
-1000   FORMAT (I4,2X,'(',I3,',',I3,')',3X,I4,2X,I4,3X,I4,2X,I4,2X,I3,1X,I3, &
-               2(2X,I4,':',I4))
+       PRINT*, 'myid   pcoord    left right  south north  idx idy   nxl: nxr','   nys: nyn'
+       PRINT*, '------------------------------------------------------------','-----------'
+       WRITE (*,1000)  0, pcoord(1), pcoord(2), pleft, pright, psouth, pnorth, myidx, myidy, nxl,  &
+                       nxr, nys, nyn
+1000   FORMAT (I4,2X,'(',I3,',',I3,')',3X,I4,2X,I4,3X,I4,2X,I4,2X,I3,1X,I3,2(2X,I4,':',I4))
 
 !
 !--    Receive data from the other PEs
        DO  i = 1,numprocs-1
-          CALL MPI_RECV( ibuf, 12, MPI_INTEGER, i, MPI_ANY_TAG, comm2d, status, &
-                         ierr )
+          CALL MPI_RECV( ibuf, 12, MPI_INTEGER, i, MPI_ANY_TAG, comm2d, status, ierr )
           WRITE (*,1000)  i, ( ibuf(j) , j = 1,12 )
        ENDDO
@@ -626,20 +604,20 @@
        ibuf(8) = myidy; ibuf(9) = nxl; ibuf(10) = nxr; ibuf(11) = nys
        ibuf(12) = nyn
-       CALL MPI_SEND( ibuf, 12, MPI_INTEGER, 0, myid, comm2d, ierr )       
+       CALL MPI_SEND( ibuf, 12, MPI_INTEGER, 0, myid, comm2d, ierr )
     ENDIF
 #endif
 
-! 
+!
 !-- Determine the number of ghost point layers
-    IF ( scalar_advec   == 'ws-scheme'  .OR.                                   &
+    IF ( scalar_advec   == 'ws-scheme'  .OR.                                                       &
          momentum_advec == 'ws-scheme'  .OR.  nested_run )  THEN
        nbgp = 3
     ELSE
        nbgp = 1
-    ENDIF 
-
-!
-!-- Check that the number of computational grid points is not smaller than the number of
-!-- ghost points.
+    ENDIF
+
+!
+!-- Check that the number of computational grid points is not smaller than the number of ghost
+!-- points.
     IF ( nnx < nbgp )  THEN
        WRITE( message_string, * ) 'number of subdomain grid points along x (', nnx, ') is smaller',&
@@ -654,6 +632,6 @@
 
 !
-!-- Create a new MPI derived datatype for the exchange of surface (xy) data,
-!-- which is needed for coupled atmosphere-ocean runs.
+!-- Create a new MPI derived datatype for the exchange of surface (xy) data, which is needed for
+!-- coupled atmosphere-ocean runs.
 !-- First, calculate number of grid points of an xy-plane.
     ngp_xy  = ( nxr - nxl + 1 + 2 * nbgp ) * ( nyn - nys + 1 + 2 * nbgp )
@@ -662,5 +640,5 @@
 
     IF ( TRIM( coupling_mode ) /= 'uncoupled' )  THEN
-   
+
 !
 !--    Pass the number of grid points of the atmosphere model to
@@ -673,35 +651,26 @@
           IF ( myid == 0 )  THEN
 
-             CALL MPI_SEND( nx_a, 1, MPI_INTEGER, numprocs, 1, comm_inter,  &
-                            ierr )
-             CALL MPI_SEND( ny_a, 1, MPI_INTEGER, numprocs, 2, comm_inter,  &
-                            ierr )
-             CALL MPI_SEND( pdims, 2, MPI_INTEGER, numprocs, 3, comm_inter, &
-                            ierr )
-             CALL MPI_RECV( nx_o, 1, MPI_INTEGER, numprocs, 4, comm_inter,  &
-                            status, ierr )
-             CALL MPI_RECV( ny_o, 1, MPI_INTEGER, numprocs, 5, comm_inter,  &
-                            status, ierr )
-             CALL MPI_RECV( pdims_remote, 2, MPI_INTEGER, numprocs, 6,      &
-                            comm_inter, status, ierr )
+             CALL MPI_SEND( nx_a, 1, MPI_INTEGER, numprocs, 1, comm_inter, ierr )
+             CALL MPI_SEND( ny_a, 1, MPI_INTEGER, numprocs, 2, comm_inter,  ierr )
+             CALL MPI_SEND( pdims, 2, MPI_INTEGER, numprocs, 3, comm_inter, ierr )
+             CALL MPI_RECV( nx_o, 1, MPI_INTEGER, numprocs, 4, comm_inter, status, ierr )
+             CALL MPI_RECV( ny_o, 1, MPI_INTEGER, numprocs, 5, comm_inter, status, ierr )
+             CALL MPI_RECV( pdims_remote, 2, MPI_INTEGER, numprocs, 6, comm_inter, status, ierr )
           ENDIF
 
           CALL MPI_BCAST( nx_o, 1, MPI_INTEGER, 0, comm2d, ierr )
-          CALL MPI_BCAST( ny_o, 1, MPI_INTEGER, 0, comm2d, ierr ) 
+          CALL MPI_BCAST( ny_o, 1, MPI_INTEGER, 0, comm2d, ierr )
           CALL MPI_BCAST( pdims_remote, 2, MPI_INTEGER, 0, comm2d, ierr )
-       
+
        ELSEIF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
 
           nx_o = nx
-          ny_o = ny 
-
-          IF ( myid == 0 ) THEN
-
-             CALL MPI_RECV( nx_a, 1, MPI_INTEGER, 0, 1, comm_inter, status, &
-                            ierr )
-             CALL MPI_RECV( ny_a, 1, MPI_INTEGER, 0, 2, comm_inter, status, &
-                            ierr )
-             CALL MPI_RECV( pdims_remote, 2, MPI_INTEGER, 0, 3, comm_inter, &
-                            status, ierr )
+          ny_o = ny
+
+          IF ( myid == 0 )  THEN
+
+             CALL MPI_RECV( nx_a, 1, MPI_INTEGER, 0, 1, comm_inter, status, ierr )
+             CALL MPI_RECV( ny_a, 1, MPI_INTEGER, 0, 2, comm_inter, status, ierr )
+             CALL MPI_RECV( pdims_remote, 2, MPI_INTEGER, 0, 3, comm_inter, status, ierr )
              CALL MPI_SEND( nx_o, 1, MPI_INTEGER, 0, 4, comm_inter, ierr )
              CALL MPI_SEND( ny_o, 1, MPI_INTEGER, 0, 5, comm_inter, ierr )
